#if (MCU == atmega168 || MCU == atmega328p ||MCU == atmega644 || MCU == atmega1284)

#define TXEN TXEN0
#define RXEN RXEN0
#define UCSRA UCSR0A
#define UCSRB UCSR0B
#define UBRRH UBRR0H
#define UBRRL UBRR0L
#define UDRE UDRE0
#define UDR UDR0
#define RXC RXC0
#define FE FE0
#define TXC TXC0
#define RXCIE RXCIE0
#define SIG_OUTPUT_COMPARE2 SIG_OUTPUT_COMPARE2A
#define GICR EIMSK
#define UCSRC UCSR0C
#define UCSZ0 UCSZ00
#define UCSZ1 UCSZ01
#define USBS USBS0
#define URSEL USBS0

#if (MCU != atmega644 && MCU != atmega1284)
enum {
  STOP             = 0,
  CK               = 1,
  CK8              = 2,
  CK64             = 3,
  CK256            = 4,
  CK1024           = 5,
  T0_FALLING_EDGE  = 6,
  T0_RISING_EDGE   = 7
};
#endif

#define SIG_UART_RECV SIG_USART_RECV 

#ifndef SIG_INTERRUPT0
#define SIG_INTERRUPT0 INT0_vect
#endif

#ifndef SIG_INTERRUPT1
#define SIG_INTERRUPT1 INT1_vect
#endif

#ifndef SIG_PIN_CHANGE0
#define SIG_PIN_CHANGE0 PCINT0_vect
#endif

#ifndef SIG_PIN_CHANGE1
#define SIG_PIN_CHANGE1 PCINT1_vect
#endif

#ifndef SIG_PIN_CHANGE2
#define SIG_PIN_CHANGE2 PCINT2_vect
#endif

#ifndef SIG_WATCHDOG_TIMEOUT
#define SIG_WATCHDOG_TIMEOUT WDT_vect
#endif

#ifndef SIG_OUTPUT_COMPARE2A
#define SIG_OUTPUT_COMPARE2A TIMER2_COMPA_vect
#endif

#ifndef SIG_OUTPUT_COMPARE2B
#define SIG_OUTPUT_COMPARE2B TIMER2_COMPB_vect
#endif

#ifndef SIG_OVERFLOW2
#define SIG_OVERFLOW2 TIMER2_OVF_vect
#endif

#ifndef SIG_INPUT_CAPTURE1
#define SIG_INPUT_CAPTURE1 TIMER1_CAPT_vect
#endif

#ifndef SIG_OUTPUT_COMPARE1A
#define SIG_OUTPUT_COMPARE1A TIMER1_COMPA_vect
#endif

#ifndef SIG_OUTPUT_COMPARE1B
#define SIG_OUTPUT_COMPARE1B TIMER1_COMPB_vect
#endif

#ifndef SIG_OVERFLOW1
#define SIG_OVERFLOW1 TIMER1_OVF_vect
#endif

#ifndef SIG_OUTPUT_COMPARE0A
#define SIG_OUTPUT_COMPARE0A TIMER0_COMPA_vect
#endif

#ifndef SIG_OUTPUT_COMPARE0B
#define SIG_OUTPUT_COMPARE0B TIMER0_COMPB_vect
#endif

#ifndef SIG_OVERFLOW0
#define SIG_OVERFLOW0 TIMER0_OVF_vect
#endif

#ifndef SIG_SPI
#define SIG_SPI SPI_STC_vect
#endif

#ifndef SIG_USART_RECV
#define SIG_USART_RECV USART_RX_vect
#endif

#ifndef SIG_USART_DATA
#define SIG_USART_DATA USART_UDRE_vect
#endif

#ifndef SIG_USART_TRANS
#define SIG_USART_TRANS USART_TX_vect
#endif

#ifndef SIG_ADC
#define SIG_ADC ADC_vect
#endif

#ifndef SIG_EEPROM_READY
#define SIG_EEPROM_READY EE_READY_vect
#endif

#ifndef SIG_COMPARATOR
#define SIG_COMPARATOR ANALOG_COMP_vect
#endif

#ifndef SIG_2WIRE_SERIAL
#define SIG_2WIRE_SERIAL TWI_vect
#endif

#ifndef SIG_TWI
#define SIG_TWI TWI_vect
#endif

#ifndef SIG_SPM_READY
#define SIG_SPM_READY SPM_READY_vect
#endif

#endif
